! Leonardo Marques, 06/89041
! Programacao para Sistemas Fisicos - Turma A

! Ambiente de desenvolvimento:
! Compilador: ifort 11.0
! Sistema Operacional: Ubuntu GNU/Linux 8.10

! Problema:
! Calcula o cross product de dois vetores
! dados

PROGRAM crossproduct; ! Começo do Programa

        ! Variaveis
        IMPLICIT NONE;
        ! Define arquivo de entrada
        CHARACTER(Len=*), PARAMETER :: input_file = './input_crossproduct.txt';
        ! Define arquivo de saída
        CHARACTER(Len=*), PARAMETER :: output_file = './output_crossproduct.txt';
        INTEGER :: estado;
        INTEGER :: counter;
        REAL, DIMENSION(2,3) :: vetores; 
        REAL, DIMENSION(3) :: crossab;

        ! Dados do programador 
        PRINT *, 'Leonardo Marques, 06/89041';
        PRINT *, 'Engenharia Elétrica, 5º semestre';
        PRINT *, 'Data de hoje 4/11/09'; 
        PRINT *, 'Programa crossproduct.'; PRINT *, '';
       
        ! Entrada dos dados 
        PRINT *, '* Lendo o arquivo de entrada: ', input_file;
        CALL leitura(input_file);
        DO counter = 1, 2, 1 
                READ(UNIT=100, FMT=*, IOSTAT=estado) vetores(counter,1),&
                & vetores(counter,2), vetores(counter,3);
                IF (estado /= 0 .AND. estado /= -1) STOP 'Erro de leitura: entrada inválida';
        END DO;

        ! Processamento dos dados
        CALL crossprod(vetores,crossab);
        
        ! Impressao dos resultados
        PRINT *, '* Impressao dos dados no arquivo: ', output_file; 
        CALL escrita(output_file);
        WRITE(UNIT=101, FMT=*) crossab(1),'i',crossab(2),'j', crossab(3),'k'; 
        
        !Funções
        CONTAINS
        SUBROUTINE crossprod(a,cross) ! Começo funcao cross
                REAL, DIMENSION(2,3), INTENT(IN) :: a;
                REAL, DIMENSION(3), INTENT(OUT) :: cross;
                cross(1) = a(1,2)*a(2,3)-a(2,2)*a(1,3); ! Calcula i
                cross(2) = -1*(a(1,1)*a(2,3)-a(2,1)*a(1,3)); ! Calcula j
                cross(3) = a(1,1)*a(2,2)-a(2,1)*a(1,2)! Calcula k
        END SUBROUTINE crossprod; ! fim funcao cross

        SUBROUTINE leitura(a); ! Abrir arquivo para leitura
                IMPLICIT NONE;
                CHARACTER(Len=*), INTENT(IN) :: a;
                INTEGER :: teste;
                OPEN(UNIT=100, FILE=a, STATUS='OLD', ACCESS='SEQUENTIAL', &
                & ACTION='READ', IOSTAT=teste);
                IF (teste /= 0) STOP 'Erro de leitura do arquivo de entrada.&
                & Gere um arquivo válido';
        END SUBROUTINE leitura; ! Fim abrir arquivo para leitura

        SUBROUTINE escrita(a); ! Abrir arquivo para escrita
                IMPLICIT NONE;
                CHARACTER(Len=*), INTENT(IN) :: a;
                OPEN(UNIT=101, FILE=a, STATUS='UNKNOWN', ACCESS='SEQUENTIAL', &
                & ACTION='WRITE');
        END SUBROUTINE escrita; ! Fim abrir arquivo para escrita

END PROGRAM crossproduct; ! Fim do programa
