! Leonardo Marques, 06/89041
! Programacao para Sistemas Fisicos - Turma A

! Ambiente de desenvolvimento:
! Compilador: gfortran
! Sistema Operacional: Mandriva 2009.1 

! Problema:
! Calcula a integral de uma dada funcao
! pelo método dos trapezios.

! Dependências: rotinas3.f90

PROGRAM trapezios; ! Começo do Programa

        ! Variaveis
        IMPLICIT NONE;
        REAL, EXTERNAL :: polinomio; ! Define funcao polinomio externa
        ! Arquivo destinado a leitura dos dados de entrada
        CHARACTER(Len=*), PARAMETER :: input = './input_trapezios.txt';
        ! Arquivo destinado aos dados de saida
        CHARACTER(Len=*), PARAMETER :: output = './output_trapezios.txt';
        INTEGER, PARAMETER :: unidade1 = 100; ! Unidades IO 
        INTEGER, PARAMETER :: unidade2 = 101; ! Uniades IO
        REAL :: limite_inferior; ! Limite inferior da integral
        REAL :: limite_superior; ! Limite superior da integral
        INTEGER :: subintervalos; ! Numero de subintervalos
        REAL :: resultado2; ! Armazena o resultado para impressao 
        INTEGER :: estado; ! Verifica se houve erro de leitura

        !Dados do programador 
        PRINT *, 'Leonardo Marques, 06/89041';
        PRINT *, 'Engenharia Elétrica, 5º semestre';
        PRINT *, 'Data de hoje 18/11/09'; 
        PRINT *, 'Programa trapezios.'; PRINT *, '';
       
        CALL leitura(input, unidade1); ! Chama rotina leitura
        
        ! Leitura dos dados
        READ(UNIT=unidade1, FMT=*, IOSTAT=estado) limite_inferior;
        READ(UNIT=unidade1, FMT=*, IOSTAT=estado) limite_superior;
        READ(UNIT=unidade1, FMT=*, IOSTAT=estado) subintervalos;

        ! Checagem dos dados de entrada
        IF (estado /= -1 .AND. estado /= 0) STOP 'erro de leitura';
        
        ! Processamento
        CALL IntTrapezios(limite_inferior,limite_superior,subintervalos,resultado2);
  
        CALL escrita(output,unidade2); ! Abre arquivo para escrita

        ! Imprime resultados
        WRITE(UNIT=unidade2, FMT=*) 'Limite inferior:',limite_inferior;
        WRITE(UNIT=unidade2, FMT=*) 'Limite superior:',limite_superior;
        WRITE(UNIT=unidade2, FMT=*) 'Numero de subintervalos:',subintervalos;
        WRITE(UNIT=unidade2, FMT=*) 'Resultado da integral:', resultado2;

        PRINT*, 'Resultado impresso em ', output;

END PROGRAM trapezios; ! Fim do programa
        
REAL FUNCTION polinomio(x) ! Inicio funcao
        REAL, INTENT(IN) :: x;

        polinomio = x**2+1.;
END FUNCTION polinomio; ! End funcao
